 	
import processing.video.*;

Capture myCamera;

color targetColor = color(255,0,0);
int[] matchingPixel = new int[2];

void setup(){
  
  size(850, 700);

println(Capture.list());

String myCam = Capture.list()[1];
myCamera = new Capture(this, width ,height, myCam, 30);
}

void draw(){
  
  image(myCamera, 0, 0);
  
  fill(targetColor);
ellipse(matchingPixel[1], matchingPixel[0], 20, 20);
}

void captureEvent(Capture myCamera) {
myCamera.read();
matchingPixel = findColor(targetColor);   
}

void mouseReleased() {
  
  targetColor = myCamera.pixels[mouseY*width+mouseX];
  
  matchingPixel[0] = mouseX;
  matchingPixel[1] = mouseY;
}

int[] findColor(color thisColor) {
  
  int[] bestPixelYet = {
    -1,-1 };
    float smallestDifference = 1000.0;
    
    for(int row=0; row<height; row++) {
      
      for(int column=0; column<width; column++) {
        
        color pixelColor = myCamera.pixels[row*width+column];
        
        float diff = abs(red(targetColor) - red(pixelColor)) +
        abs(green(targetColor) - green(pixelColor)) +
        abs(blue(targetColor) - blue(pixelColor))/3;
        
        if (diff<= smallestDifference) {
          smallestDifference = diff;
          bestPixelYet[0] = row;
          bestPixelYet[1] = column;
        }
      }
    }
    return bestPixelYet;
}
    
